#include <TimerThree.h>
#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами
#include <GW_US04.h>

#define TRIG_PIN 4 // Назначение пина, к которому подключен вывод trig ультразвукового дальномера
#define ECHO_PIN 9 // Назначение пина, к которому подключен вывод echo ультразвукового дальномера
#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_START 5 // Назначение пина, к которому подключена тактовая кнопка запуска
#define BUZZER 13 // Назначение пина, к которому подключена пьезопищалка

bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
volatile bool work_state=false; // Б.1 - Объявление переменной work_state и присвоение ей значения false
bool button_state; // Объявление переменной button_state
volatile bool on=true; // Объявление переменной on и присвоение ей значения true
volatile bool buzzer_on=true; // Б.1 - Объявление переменной buzzer_on и присвоение ей значения true
volatile bool buzzer_flag=false; // Б.1 - Объявление переменной buzzer_flag и присвоение ей значения false
bool body_find=false; // Б.1 - Объявление переменной body_find и присвоение ей значения false

int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter
int distance; // Объявление переменной distance
int timer; // Объявление переменной timer
volatile int counter_r=0; // Б.1 - Объявление переменной counter_r и присвоение ей значения 0
volatile int counter_l=0; // Б.1 - Объявление переменной counter_l и присвоение ей значения 0
volatile int temp=0; // Б.1 - Объявление переменной temp и присвоение ей значения 0
volatile int buzzer_temp=7; // Б.1 - Объявление переменной buzzer_temp и присвоение ей значения 7

void button_read(); // Объявление функции button_read()
void zapusk(); // Объявление функции zapusk()
void poisk(); // Объявление функции poisk()

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

GW_US04 sonar = GW_US04(TRIG_PIN, ECHO_PIN); // Инициализация ультразвукового дальномера и присвоение ему имени sonar

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left

pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode(BUZZER, OUTPUT); // Настройка пина BUZZER на вывод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод

Timer3.initialize(250); // Б.1 - Настройка таймера/счетчика 3 на отсчет 0,00025 с
Timer3.attachInterrupt(majak); // Инициализация функции majak, вызываемой при возникновении прерывания таймера/счетчика 1

}

void loop() {
  button_read(); // Б.2 - Вызов на исполнение функции button_read
 
  if(robot_state==true) // Б.3 - Если значение переменной robot_state равно true, то начать выполнение инструкций в скобках
  {   
  zapusk(); // Б.4 - Вызов на исполнение функции zapusk   
  
  while(robot_state==true) // Б.5 - Выполнение инструкций в скобках пока значение переменной robot_state равно true     
  {        
     distance=sonar.scan(); // Б.6 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance
     if(distance>12) // Б.7 - Если значение переменной distance больше 12, то
     {        
      motor_right->forward(speeds-30); // Б.8 - Команда на запуск мотора motor_right со скоростью speeds-30 % в прямом направлении
      motor_left->backward(speeds-30); // Б.8 - Команда на запуск мотора motor_left со скоростью speeds-30 % в обратном направлении
      work_state=false; // Б.9 - Присвоение переменной work_state значения false 
      digitalWrite(LEFT_LED,LOW); // Б.10 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
      digitalWrite(RIGHT_LED,LOW); // Б.10 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"       
     }
     else // Иначе значение переменной меньше или равно 10
     {
      body_find=true; // Б.11 - Присвоение переменной body_find значения true  
      work_state=true; // Б.21 - Присвоение переменной work_state значения true    
      while(body_find==true) // Б.12 - Выполнять цикл, пока значение переменной body_find равно true
      {          
      if(distance<=12&&distance>2) // Б.23 - Если значение переменной distance меньше или равно 12 и больше 2, то выполнять инструкции в скобках 
      {
      motor_right->forward(speeds); // Б.24 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
      motor_left->forward(speeds); // Б.24 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении      
      distance=sonar.scan(); // Б.25 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance
      delay(10); // Б.26 - Ожидание 0,01 секунду
      }      
      else if(distance<=2) // Б.27 - Если значение переменной distance меньше или равно 22, то выполнять инструкции в скобках 
      {
        motor_right->stop(false); // Б.28 - Команда на остановку вращения мотора motor_right
        motor_left->stop(false); // Б.28 - Команда на остановку вращения мотора motor_left    
        distance=sonar.scan(); // Б.29 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance
        delay(10); // Б.30 - Ожидание 0,01 секунду       
      }
      else if(distance>12) // Если значение переменной distance больше 12, то выполнять инструкции в скобках 
      {
        poisk(); // Б.31 - Передача управления функции с именем poisk()      
      }                
      }              
     }
     delay(10); // Б.13 - Ожидание 0,01 секунды    
     button_state=digitalRead(BUTTON_START); // Б.14 - Сохранение состояния на пине BUTTON_START в переменную button_state
     if(button_state==0) // Б.15 - Если значение переменной button_state равно 0, то 
     {
      robot_state=false; // Б.16 - Присвоение переменной robot_state значение false 
      motor_right->stop(false); // Б.17 - Команда на остановку вращения мотора motor_right
      motor_left->stop(false); // Б.17 - Команда на остановку вращения мотора motor_left 
      work_state=false; // Б.18 - Присвоение переменной work_state значения false  
      digitalWrite(LEFT_LED,LOW); // Б.19 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
      digitalWrite(RIGHT_LED,LOW); // Б.19 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"      
      delay(1500); // Б.20 - Ожидание 1,5 секунд      
     }     
  }
  }
         
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.2.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.2.3 - Ожидание 0,01 с
  button_state=digitalRead(BUTTON_START); // Б.2.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.2.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.2.7 - Цикл do..while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.2.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.4.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.4.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.4.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.4.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.4.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.4.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.4.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.4.6 - Ожидание 0,5 секунд
   counter=counter+1; // Б.4.7 - Увеличение значения переменной counter на 1
  }      
}

void poisk()
{
        motor_right->backward(speeds-30); // Б.31.1 - Команда на запуск мотора motor_right со скоростью speeds-30 % в обратном направлении
        motor_left->forward(speeds-30); // Б.31.1 - Команда на запуск мотора motor_left со скоростью speeds-30 % в прямом направлении
        timer=50; // Б.31.2 - Присвоение переменной timer значения 50  
        while (timer>0) // Б.31.3 - Цикл While(). Выполнять до тех пор, пока истинно выражение timer>0
        {                   
         distance=sonar.scan(); // Б.31.4 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance  
         delay(10); // Б.31.5 - Ожидание 0,01 секунды  
         if(distance<=12&&distance!=0) // Б.31.6 - Если значение переменной distance меньше или равно 12 и не равно 0, то выполнять инструкции в скобках 
      {
        body_find=true; // Б.31.7 - Присвоение переменной body_find значения true 
        break; // Команда на прерывание цикла разворота робота
      }     
       timer=timer-1; // Б.31.8 - Уменьшение значения переменной timer на 1 
       body_find=false; // Б.31.9 - Присвоение переменной body_find значения false               
      }

      if(body_find==false) // Б.31.10 - Если значение переменной body_find равно false, то выполнять инструкции в скобках
      {
        motor_right->forward(speeds-30); // Б.31.11 - Команда на запуск мотора motor_right со скоростью speeds-30 % в прямом направлении
        motor_left->backward(speeds-30); // Б.31.11 - Команда на запуск мотора motor_left со скоростью speeds-30 % в обратном направлении
        timer=100; // Б.31.12 - Присвоение переменной timer значения 100      
        while (timer>0) // Б.31.13 - Цикл While(). Выполнять до тех пор, пока истинно выражение timer>0
        {
         distance=sonar.scan(); // Б.31.14 - Сохранение значения, возвращаемого функцией sonar.scan() в переменную distance 
         delay(10); // Б.31.15 - Ожидание 0,01 секунды 
         if(distance<=12&&distance!=0) // Б.31.16 - Если значение переменной distance меньше или равно 12 и не равно 0, то выполнять инструкции в скобках 
      {
        body_find=true; // Б.31.17 - Присвоение переменной body_find значения true 
        break; // Команда на прерывание цикла разворота робота
      }      
        timer=timer-1; // Б.31.18 - Уменьшение значения переменной timer на 1         
        body_find=false; // Б.31.19 - Присвоение переменной body_find значения false        
      }      
      }
      
      if(body_find==false) // Б.31.20 - Если значение переменной body_find равно false, то выполнять инструкции в скобках
      {
        work_state=false; // Б.31.21 - Присвоение переменной work_state значения false                          
      }
}

void majak()
{
  if(work_state==true) // Б.13.1 - Если значение переменной work_state равно true, то выполнять инструкции в скобках 
  {
  temp++; // Б.13.2 - Увеличение значения переменной temp на 1
  if(temp%200==0) // Б.13.3 - Если остаток от деления значения переменной temp на 200 равен 0, то выполнять инструкции в скобках
  {
  if(counter_r<9) // Б.13.4 - Если значение переменной counter_r меньше 9, то выполнять инструкции в скобках 
  {
    digitalWrite(LEFT_LED, LOW); // Б.13.8 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
    digitalWrite(RIGHT_LED, on); // Б.13.9 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "on"
    on=!on; // Б.13.9 - Присвоение переменной on противоположного значения этой же переменной
    counter_r++; // Б.13.10 - Увеличение значения переменной counter_r на 1   
  }
  else
  {
    digitalWrite(RIGHT_LED, LOW); // Б.13.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
    digitalWrite(LEFT_LED, on); // Б.13.6 - Установить на пине LEFT_LED напряжение, соответствующее уровню "on"
    on=!on; // Б.13.6 - Присвоение переменной on противоположного значения этой же переменной
    counter_l++; // Б.13.7 - Увеличение значения переменной counter_l на 1    
    if(counter_l>9) // Б.13.11 - Если значение переменной counter_l больше 9, то выполнять инструкции в скобках 
    {
      counter_l=0; // Б.13.12 - Присвоение переменной counter_l значения 0
      counter_r=0; // Б.13.13 - Присвоение переменной counter_r значения 0
    }
  }
  }  

  if(temp%buzzer_temp==0) // Б.13.14 - Если остаток от деления значения переменной temp на значение переменной buzzer_temp равен 0, то выполнять инструкции в скобках 
  {
  digitalWrite(BUZZER,buzzer_on); // Б.13.15 - Установить на пине BUZZER напряжение, соответствующее уровню "buzzer_on"
  buzzer_on=!buzzer_on; // Б.13.15 - Присвоение переменной buzzer_on противоположного значения этой же переменной
  }
  if(temp%170==0) // Б.13.16 - Если остаток от деления значения переменной temp на 170 равен 0, то выполнять инструкции в скобках
  {
    if(buzzer_flag==0) // Б.13.17 - Если значение переменной buzzer_flag равно 0, то выполнять инструкции в скобках
    {
      buzzer_temp++; // Б.13.19 - Увеличение значения переменной buzzer_temp на 1  
      if(buzzer_temp==20) // Б.13.21 - Если значение переменной buzzer_temp равно 20, то выполнять инструкции в скобках
      {
        buzzer_flag=true; // Б.13.23 - Присвоение переменной buzzer_flag значения true
      }
    }
    else
    {
      buzzer_temp--; // Б.13.18 - Уменьшение значения переменной buzzer_temp на 1  
      if(buzzer_temp==7) // Б.13.20 - Если значение переменной buzzer_temp равно 7, то выполнять инструкции в скобках
      {
         buzzer_flag=false; // Б.13.22 - Присвоение переменной buzzer_flag значения false
      }
    }    
  }  
  }  
}
